% demo for using the iPatch program
% mrqiangluo@gmail.com

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Paramters Setting Section  
%
% Please set the parameters for your proteins
%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%
%   For INPUT    %
%%%%%%%%%%%%%%%%%%

%% For the fitting data set

%% protein 1
MSAfile{1} = 'aln1A45_seqs_nr90.fasta';
pdbfile1{1} = '1A45.pdb';
pdbfile2{1} = '1A45.pdb';
jobname{1} = '1A45';
segments{1}.number{1} = [1,82]; 
segments{1}.number{2} = [83,173]; 
segments{1}.chain = {'A','A'};
location{1}{1} = [1, 82] ;  
location{1}{2} = [83, 173]; 

%% protein 2
MSAfile{2} = 'aln1ALC_seqs_nr90.fasta';
pdbfile1{2} = '1ALC.pdb';
pdbfile2{2} = '1ALC.pdb';
jobname{2} = '1ALC';
segments{2}.number{1} = [1,37;105,122]; 
segments{2}.number{2} = [38,104];
segments{2}.chain = {'A','A'};
location{2}{1} = [1,37; 105,123] ;  
location{2}{2} = [38, 104];



%% protein 3
MSAfile{3} = 'aln1N0J_seqs_nr90.fasta';
pdbfile1{3} = '1N0J.pdb';
pdbfile2{3} = '1N0J.pdb';
jobname{3} = '1N0J';
segments{3}.number{1} = [1,81]; 
segments{3}.number{2} = [91,198]; 
segments{3}.chain = {'A','A'};
location{3}{1} = [1, 81] ;  
location{3}{2} = [82, 198]; 

%% protein 4
MSAfile{4} = 'aln1BIB_seqs_nr90.fasta';
pdbfile1{4} = '1BIB.pdb';
pdbfile2{4} = '1BIB.pdb';
jobname{4} = '1BIB';
segments{4}.number{1} = [1,66]; 
segments{4}.number{2} = [67,270]; 
segments{4}.chain = {'A','A'};
location{4}{1} = [1, 66] ;  
location{4}{2} = [67, 321]; 

%% protein 5
MSAfile{5}            = 'aln1FNB_seqs_nr90.fasta';
pdbfile1{5}           = '1FNB.pdb';
pdbfile2{5}           = '1FNB.pdb';
jobname{5}            = '1FNB';
segments{5}.number{1} = [19,152]; 
segments{5}.number{2} = [153, 314]; 
segments{5}.chain     = {'A','A'};
location{5}{1}        = [1, 152] ;  
location{5}{2}        = [153, 314]; 

%% protein 6
MSAfile{6} = 'aln1PII_seqs_nr90.fasta';
pdbfile1{6} = '1PII.pdb';
pdbfile2{6} = '1PII.pdb';
jobname{6} = '1PII';
segments{6}.number{1} = [1, 255]; 
segments{6}.number{2} = [256, 452]; 
segments{6}.chain = {'A','A'};
location{6}{1} = [1, 255] ;  
location{6}{2} = [256, 452]; 

%% protein 7
MSAfile{7} = 'aln1RHD_seqs_nr90.fasta';
pdbfile1{7} = '1RHD.pdb';
pdbfile2{7} = '1RHD.pdb';
jobname{7} = '1RHD';
segments{7}.number{1} = [1, 156]; 
segments{7}.number{2} = [157, 293]; 
segments{7}.chain = {'A','A'};
location{7}{1} = [1, 156] ;  
location{7}{2} = [157, 293]; 

%% protein 8
MSAfile{8} = 'aln2AAA_seqs_nr90.fasta';
pdbfile1{8} = '2AAA.pdb';
pdbfile2{8} = '2AAA.pdb';
jobname{8} = '2AAA';
segments{8}.number{1} = [1, 376]; 
segments{8}.number{2} = [377, 476]; 
segments{8}.chain = {'A','A'};
location{8}{1} = [1, 376] ;  
location{8}{2} = [377, 484]; 


%% protein 9
MSAfile{9} = 'aln2PIA_seqs_nr90.fasta';
pdbfile1{9} = '2PIA.pdb';
pdbfile2{9} = '2PIA.pdb';
jobname{9} = '2PIA';
segments{9}.number{1} = [1, 104]; 
segments{9}.number{2} = [105, 225]; 
segments{9}.chain = {'A','A'};
location{9}{1} = [1, 104] ;  
location{9}{2} = [105, 321]; 

%% protein 10
MSAfile{10} = 'aln8TLN_seqs_nr90.fasta';
pdbfile1{10} = '8TLN.pdb';
pdbfile2{10} = '8TLN.pdb';
jobname{10} = '8TLN';
segments{10}.number{1} = [1, 135]; 
segments{10}.number{2} = [136, 316]; 
segments{10}.chain = {'E','E'};
location{10}{1} = [1, 135] ;  
location{10}{2} = [136, 316]; 

%% protein 11
MSAfile{11} = 'aln4ENL_seqs_nr90.fasta';
pdbfile1{11} = '4ENL.pdb';
pdbfile2{11} = '4ENL.pdb';
jobname{11} = '4ENL';
segments{11}.number{1} = [1, 126]; 
segments{11}.number{2} = [127, 436]; 
segments{11}.chain = {'A','A'};
location{11}{1} = [1, 126] ;  
location{11}{2} = [127, 436]; 

%% protein 12
MSAfile{12} = 'aln8ATC_seqs_nr90.fasta';
pdbfile1{12} = '8ATC.pdb';
pdbfile2{12} = '8ATC.pdb';
jobname{12} = '8ATC';
segments{12}.number{1} = [8, 97]; 
segments{12}.number{2} = [98, 153]; 
segments{12}.chain = {'B','B'};
location{12}{1} = [1, 97] ;  
location{12}{2} = [98, 153]; 


%% protein 13
MSAfile{13} = 'aln6GST_seqs_nr90.fasta';
pdbfile1{13} = '6GST.pdb';
pdbfile2{13} = '6GST.pdb';
jobname{13} = '6GST';
segments{13}.number{1} = [1, 82]; 
segments{13}.number{2} = [90, 217]; 
segments{13}.chain = {'A','A'};
location{13}{1} = [1, 82] ;  
location{13}{2} = [83, 217]; 

%% protein 14
MSAfile{14} = 'aln1LLD_seqs_nr90.fasta';
pdbfile1{14} = '1LLD.pdb';
pdbfile2{14}= '1LLD.pdb';
jobname{14} = '1LLD';
segments{14}.number{1} = [7, 148]; 
segments{14}.number{2} = [149, 319]; 
segments{14}.chain = {'A','A'};
location{14}{1} = [1, 148] ;  
location{14}{2} = [149, 319]; 

%% protein 15
MSAfile{15} = 'aln1THM_seqs_nr90.fasta';
pdbfile1{15} = '1THM.pdb';
pdbfile2{15} = '1THM.pdb';
jobname{15} = '1THM';
segments{15}.number{1} = [1,127]; 
segments{15}.number{2} = [128, 208]; 
segments{15}.chain = {'A','A'};
location{15}{1} = [1, 127] ;  
location{15}{2} = [128, 208]; 

%% protein 16
MSAfile{16} = 'aln1BKS_seqs_nr90.fasta';
pdbfile1{16} = '1BKS.pdb';
pdbfile2{16} = '1BKS.pdb';
jobname{16} = '1BKS';
segments{16}.number{1} = [1,188]; 
segments{16}.number{2} = [189, 268]; 
segments{16}.chain = {'A','A'};
location{16}{1} = [1, 188] ;  
location{16}{2} = [189, 268]; 

%% protein 17
MSAfile{17} = 'aln2REB_seqs_nr90.fasta';
pdbfile1{17}  = '2REB.pdb';
pdbfile2{17}  = '2REB.pdb';
jobname{17}  = '2REB';
segments{17} .number{1} = [23,268]; 
segments{17} .number{2} = [269, 328]; 
segments{17} .chain = {'A','A'};
location{17} {1} = [1, 268] ;  
location{17} {2} = [269, 352]; 

%% protein 18
MSAfile{18}  = 'aln2TS1_seqs_nr90.fasta';
pdbfile1{18}  = '2TS1.pdb';
pdbfile2{18}  = '2TS1.pdb';
jobname{18}  = '2TS1';
segments{18} .number{1} = [1,220]; 
segments{18} .number{2} = [248, 319]; 
segments{18} .chain = {'A','A'};
location{18} {1} = [1, 220] ;  
location{18} {2} = [221, 419]; 

%% protein 19
MSAfile{19}  = 'aln3PSG_seqs_nr90.fasta';
pdbfile1{19}  = '3PSG.pdb';
pdbfile2{19} = '3PSG.pdb';
jobname{19} = '3PSG';
segments{19}.number{1} = [45, 214]; 
segments{19}.number{2} = [224, 370]; 
segments{19}.chain = {'A','A'};
location{19}{1} = [1, 214] ;  
location{19}{2} = [215, 370];

%% protein 20
MSAfile{20} = 'aln4MDH_seqs_nr90.fasta';
pdbfile1{20} = '4MDH.pdb';
pdbfile2{20} = '4MDH.pdb';
jobname{20} = '4MDH';
segments{20}.number{1} = [1, 154]; 
segments{20}.number{2} = [155, 333]; 
segments{20}.chain = {'A','A'};
location{20}{1} = [1, 154] ;  
location{20}{2} = [155, 333]; 

%% protein 21
MSAfile{21} = 'aln5FBP_seqs_nr90.fasta';
pdbfile1{21} = '5FBP.pdb';
pdbfile2{21} = '5FBP.pdb';
jobname{21} = '5FBP';
segments{21}.number{1} = [1, 201]; 
segments{21}.number{2} = [202, 335]; 
segments{21}.chain = {'A','A'};
location{21}{1} = [1, 201] ;  
location{21}{2} = [202, 335]; 

%% protein 22
MSAfile{22} = 'aln1LAP_seqs_nr90.fasta';
pdbfile1{22} = '1LAP.pdb';
pdbfile2{22} = '1LAP.pdb';
jobname{22} = '1LAP';
segments{22}.number{1} = [1, 147]; 
segments{22}.number{2} = [148, 484]; 
segments{22}.chain = {'A','A'};
location{22}{1} = [1, 147] ;  
location{22}{2} = [148, 487];

%% protein 23
MSAfile{23} = 'aln2PGD_seqs_nr90.fasta';
pdbfile1{23} = '2PGD.pdb';
pdbfile2{23} = '2PGD.pdb';
jobname{23} = '2PGD';
segments{23}.number{1} = [1, 172]; 
segments{23}.number{2} = [178, 433]; 
segments{23}.chain = {'A','A'};
location{23}{1} = [1, 172] ;  
location{23}{2} = [173, 482];


%% protein 24
MSAfile{24} = 'aln9PAP_seqs_nr90.fasta';
pdbfile1{24} = '9PAP.pdb';
pdbfile2{24} = '9PAP.pdb';
jobname{24} = '9PAP';
segments{24}.number{1} = [1, 9; 113, 207]; 
segments{24}.number{2} = [10, 112; 208, 212]; 
segments{24}.chain = {'A','A'};
location{24}{1} = [1, 9; 113, 207] ;  
location{24}{2} = [10, 112; 208, 212];

%% protein 25
MSAfile{25} = 'aln3BLM_seqs_nr90.fasta';
pdbfile1{25} = '3BLM.pdb';
pdbfile2{25} = '3BLM.pdb';
jobname{25} = '3BLM';
segments{25}.number{1} = [31,67;168,287]; 
segments{25}.number{2} = [69,154]; 
segments{25}.chain = {'A','A'};
location{25}{1} = [1,36; 135,257] ;  
location{25}{2} = [37, 134]; % these locations all together must cover the whole reference seqeunce

%% protein 26
MSAfile{26} = 'aln1GPB_seqs_nr90.fasta';
pdbfile1{26}  = '1GPB.pdb';
pdbfile2{26}  = '1GPB.pdb';
jobname{26}  = '1GPB';
segments{26}.number{1} = [485,811]; 
segments{26}.number{2} = [19,484; 812,831]; 
segments{26}.chain = {'A','A'};
location{26}{1} = [485, 811];
location{26}{2} = [1, 484; 812, 842];


%% protein 27
MSAfile{27} = 'aln2HAD_seqs_nr90.fasta';
pdbfile1{27} = '2HAD.pdb';
pdbfile2{27} = '2HAD.pdb';
jobname{27} = '2HAD';
segments{27}.number{1} = [1, 155; 230, 310]; 
segments{27}.number{2} = [156, 229]; 
segments{27}.chain = {'A','A'};
location{27}{1} = [1, 155; 230,310];
location{27}{2} = [156, 229];

%% protein 28
MSAfile{28} = 'aln3PGK_seqs_nr90.fasta';
pdbfile1{28} = '3PGK.pdb';
pdbfile2{28} = '3PGK.pdb';
jobname{28} = '3PGK';
segments{28}.number{1} = [203,386];
segments{28}.number{2} = [1,202; 387,415]; 
segments{28}.chain = {'A','A'};
location{28}{1} = [203,386];
location{28}{2} = [1,202;387,415];

%% protein 29
MSAfile{29} = 'aln1PDA_seqs_nr90.fasta';
pdbfile1{29} = '1PDA.pdb';
pdbfile2{29} = '1PDA.pdb';
jobname{29} = '1PDA';
segments{29}.number{1} = [3,99;200,220]; 
segments{29}.number{2} = [100,199];
segments{29}.chain = {'A','A'};
location{29}{1} = [1,99;200,313]; 
location{29}{2} = [100,199];


%% protein 30
MSAfile{30} = 'aln2CYP_seqs_nr90.fasta';
pdbfile1{30} = '2CYP.pdb';
pdbfile2{30} = '2CYP.pdb';
jobname{30} = '2CYP';
segments{30}.number{1} =  [2,144;255,294]; 
segments{30}.number{2} = [145,253];
segments{30}.chain = {'A','A'};
location{30}{1} =  [1,144; 255,294]; 
location{30}{2} = [145,254];

%% protein 31
MSAfile{31} = 'aln3GBP_seqs_nr90.fasta';
pdbfile1{31}  = '3GBP.pdb';
pdbfile2{31}  = '3GBP.pdb';
jobname{31}  = '3GBP';
segments{31} .number{1} = [3,110;258,293];  
segments{31} .number{2} = [111,257;294,307];
segments{31} .chain = {'A','A'};
location{31} {1} = [1,110; 258,293];
location{31} {2} = [111,257; 294,307];

%% protein 32
MSAfile{32}  = 'aln1BIB2_seqs_nr90.fasta';
pdbfile1{32}  = '1BIB2.pdb';
pdbfile2{32}  = '1BIB2.pdb';
jobname{32}  = '1BIB2';
segments{32} .number{1} = [67,270];
segments{32} .number{2} = [271,317];
segments{32} .chain = {'A','A'};
location{32} {1} = [1, 270];
location{32} {2} = [271, 321];

%% protein 33
MSAfile{33}  = 'aln2PIA3_seqs_nr90.fasta';
pdbfile1{33}  = '2PIA3.pdb';
pdbfile2{33}  = '2PIA3.pdb';
jobname{33}  = '2PIA3';
segments{33}.number{1} = [1,104]; 
segments{33}.number{2} = [226,321];
segments{33}.chain = {'A','A'};
location{33}{1} = [1, 104];
location{33}{2} = [105, 321];

%% protein 34
MSAfile{34} = 'aln1PDA2_seqs_nr90.fasta';
pdbfile1{34} = '1PDA2.pdb';
pdbfile2{34} = '1PDA2.pdb';
jobname{34} = '1PDA2';
segments{34}.number{1} = [100,199]; 
segments{34}.number{2} = [221,307];
segments{34}.chain = {'A','A'};
location{34}{1} = [1, 199];
location{34}{2} = [200, 313];

%% protein 35
MSAfile{35} = 'aln1PDA3_seqs_nr90.fasta';
pdbfile1{35} = '1PDA3.pdb';
pdbfile2{35} = '1PDA3.pdb';
jobname{35} = '1PDA3';
segments{35}.number{1} = [3,99;200,220]; 
segments{35}.number{2} = [221,307];
segments{35}.chain = {'A','A'};
location{35}{1} = [1,99; 100, 220];
location{35}{2} = [221, 313];

%% testing data set







%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Detailed parameters for iPatch algorithm %
% these are the default settings below           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear parameters;
parameters.surfaceoption = 0; % if set to 0,the surface information for the domain interested is
                              % given by running the psa on the domain; if set it to
                              % 1, the surface information for the domain interested is
                              % given by running the psa on the whole protein on
                              % which this domain is located;
parameters.gapcutoff = 0.5;   % columns with gap percentage greater than this cutoff wont be used in the score calculation
parameters.discutoff = 4.5;   % the intra domain space neighbors are defined by this cutoff, i.e., if the distances 
                              % between residues that are measured as the
                              % shortest distance between any nonhydrogen atoms
                              % are less than this cutoff, these two
                              % residues are intra domain neighbors
parameters.parallelized = 0;  % 1, if you can run the matlabpool, most of the algorithms can be
                              % parallelized; 0, otherwise.
parameters.randomized = 0;    % 1, if you want to get the scores for the random matching pairs as backgroud score; 0, otherwise.
parameters.reference = 1;     % 1, if you want to include your reference sequence in the score calculation; 0, otherwise.  
parameters.cleancache = 1;    % clean all the cache files; if set to be 0, the cache files will be used, if any
parameters.modifiedres = 1;   % if 1, change MSE to MET, CSE to CSC; if 0, those modified residues will be ignored.
parameters.manualalignment = 0; % if 0, the alignment between the pdb sequence and the reference sequence 
                                % will be generated by using the local alignment algorithm swalign(); 
                                % if 1, the user specified alignment will be used for the residue number 
                                % assignment 

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Calculating scores  
%
%
%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
matlabpool
for pri = 1 : size(MSAfile,2)
    pri
    %% calling the iPatch
    result{pri} = iPatch(pdbfile1{pri}, pdbfile2{pri}, MSAfile{pri}, location{pri}, segments{pri}, jobname{pri}, parameters);
end
matlabpool close
    % output data structure
    % result.pairwisescores{1} pairPPro
    % result.pairwisescores{2} pairTPro
    % result.pairwisescores{3} pairMcBASC
    % result.sitescores{1} APro
    % result.sitescores{2} PPro
    % result.sitescores{3} TPro
    % result.sitescores{4} EBMcBASC
    % result.sitescores{5} Comb
    % result.protein  a structure data format with many fields
save('resultfittingdata.mat','result')


