%% Demo for test data set using i-Patch
% Qiang LUO
% Department of Statisitcs, University of Oxford
% mrqiangluo@gmail.com
% last editied on 2009.12.30

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Paramters Setting Section  
%
% Please set the parameters for your proteins
%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%
%   For INPUT    %
%%%%%%%%%%%%%%%%%%


%% protein 1
MSAfile{1} = 'MMM2E64_hits_nr90_2E64A_nr90.fasta';
pdbfile1{1} = '2e64a.pdb';
pdbfile2{1} = '2e64a.pdb';
jobname{1} = '2e64a';
segments{1}.number{1} = [1,188]; 
segments{1}.number{2} = [189,235];
segments{1}.chain = {'A','A'};
location{1}{1} = [1,188]; 
location{1}{2} = [189,235];

%% protein 2
MSAfile{2} = 'MMM2NRC_hits_nr90_2NRCA_nr90.fasta';
pdbfile1{2} = '2nrca.pdb';
pdbfile2{2} = '2nrca.pdb';
jobname{2} = '2nrca';
segments{2}.number{1} = [1,247]; 
segments{2}.number{2} = [261,480];
segments{2}.chain = {'A','A'};
location{2}{1} = [1,247]; 
location{2}{2} = [248,481];

%% protein 3
MSAfile{3} = 'MMM2OI8_hits_nr90_2OI8A_nr90.fasta';
pdbfile1{3} = '2oi8a.pdb';
pdbfile2{3} = '2oi8a.pdb';
jobname{3} = '2oi8a';
segments{3}.number{1} =  [8,86];  
segments{3}.number{2} = [87,216];
segments{3}.chain = {'A','A'};
location{3}{1} = [1,86]; 
location{3}{2} = [87,216];

%% protein 4
MSAfile{4} = 'MMM2QY9_hits_nr90_2QY9A_nr90.fasta';
pdbfile1{4} = '2qy9a.pdb';
pdbfile2{4} = '2qy9a.pdb';
jobname{4} = '2qy9a';
segments{4}.number{1} =  [201,284];
segments{4}.number{2} = [285,495];
segments{4}.chain = {'A','A'};
location{4}{1} = [1,90]; 
location{4}{2} = [91,309];

%% protein 5
MSAfile{5} = 'MMM1W98_hits_nr90.fasta';
pdbfile1{5} = '1w98b.pdb';
pdbfile2{5} = '1w98b.pdb';
jobname{5} = '1w98b';
segments{5}.number{1} = [88,227];  
segments{5}.number{2} = [228,357];
segments{5}.chain = {'B','B'};
location{5}{1} = [1,147]; 
location{5}{2} = [148,283];

%% protein 6
MSAfile{6} = 'MMM1WRU_hits_nr90_1WRUA_nr90.fasta';
pdbfile1{6} = '1wrua.pdb';
pdbfile2{6} = '1wrua.pdb';
jobname{6} = '1wrua';
segments{6}.number{1} = [3,176];  
segments{6}.number{2} = [177,346];
segments{6}.chain =  {'A','A'};
location{6}{1} = [1,176]; 
location{6}{2} = [177,379];

%% protein 7
MSAfile{7} = 'MMM1X2G_hits_nr90_1X2GA_nr90.fasta';
pdbfile1{7} = '1x2ga.pdb';
pdbfile2{7} = '1x2ga.pdb';
jobname{7} = '1x2ga';
segments{7}.number{1} = [1,246]; 
segments{7}.number{2} = [247,337];
segments{7}.chain =  {'A','A'};
location{7}{1} = [1,246]; 
location{7}{2} = [247,337];


%% protein 8
MSAfile{8} = 'MMM2I00_hits_nr90_2I00A_nr90.fasta';
pdbfile1{8} = '2i00a.pdb';
pdbfile2{8} = '2i00a.pdb';
jobname{8} = '2i00a';
segments{8}.number{1} =  [10,300]; 
segments{8}.number{2} =  [301,406];
segments{8}.chain =  {'A','A'};
location{8}{1} = [1,300]; 
location{8}{2} = [301,406];

%% protein 9
MSAfile{9} = 'MMM2IU5_hits_nr90_2IU5A_nr90.fasta';
pdbfile1{9}  = '2iu5a.pdb';
pdbfile2{9}  = '2iu5a.pdb';
jobname{9}  = '2iu5a';
segments{9} .number{1} =  [1,71]; 
segments{9} .number{2} =  [72,180];
segments{9} .chain =  {'A','A'};
location{9} {1} = [1,78]; 
location{9} {2} = [79,195];

%% protein 10
MSAfile{10}  = 'MMM2AHEA_hits_nr90.fasta';
pdbfile1{10} = '2ahea.pdb';
pdbfile2{10} = '2ahea.pdb';
jobname{10} = '2ahea';
segments{10}.number{1} = [16,108]; 
segments{10}.number{2} = [109,253];
segments{10}.chain =  {'A','A'};
location{10}{1} = [1,108]; 
location{10}{2} = [109,267];


%% protein 11
MSAfile{11} = 'MMM3APRE_hits_nr90_3APRE_nr90.fasta';
pdbfile1{11} = '3apre.pdb';
pdbfile2{11} = '3apre.pdb';
jobname{11} = '3apre';
segments{11}.number{1} =[6,174]; 
segments{11}.number{2} = [175,323];
segments{11}.chain =  {'E','E'};
location{11}{1} = [1,174]; 
location{11}{2} = [175,325];


%% protein 12
MSAfile{12} = 'MMM2BJVA_hits_nr90_2BJVA_nr90.fasta';
pdbfile1{12} = '2bjva.pdb';
pdbfile2{12} = '2bjva.pdb';
jobname{12} = '2bjva';
segments{12}.number{1} = [10,177];  
segments{12}.number{2} =[178,257];
segments{12}.chain =   {'A','A'};
location{12}{1} = [1,177]; 
location{12}{2} = [178,265];

%% protein 13
MSAfile{13} = 'MMM2CXCA_hits_nr90_2CXCA_nr90.fasta';
pdbfile1{13} = '2cxca.pdb';
pdbfile2{13} = '2cxca.pdb';
jobname{13} = '2cxca';
segments{13}.number{1} = [7,75]; 
segments{13}.number{2} = [76,144];
segments{13}.chain =   {'A','A'};
location{13}{1} = [1,75]; 
location{13}{2} = [76,144];

%% protein 14
MSAfile{14} = 'MMM2D3VA_hits_nr90_2D3VA_nr90.fasta';
pdbfile1{14} = '2d3va.pdb';
pdbfile2{14} = '2d3va.pdb';
jobname{14} = '2d3va';
segments{14}.number{1} = [3,95];  
segments{14}.number{2} = [96,195];
segments{14}.chain =   {'A','A'};
location{14}{1} = [1,95]; 
location{14}{2} = [96,196];

%% protein 15
MSAfile{15} = 'MMM2D8NA_hits_nr90_2D8NA_nr90.fasta';
pdbfile1{15} = '2d8na.pdb';
pdbfile2{15} = '2d8na.pdb';
jobname{15} = '2d8na';
segments{15}.number{1} = [16,97]; 
segments{15}.number{2} = [102,189];
segments{15}.chain =   {'A','A'};
location{15}{1} = [1,104]; 
location{15}{2} = [105,207];


%% protein 16
MSAfile{16} = 'MMM2DYIA_hits_nr90_2DYIA_nr90.fasta';
pdbfile1{16} = '2dyia.pdb';
pdbfile2{16} = '2dyia.pdb';
jobname{16} = '2dyia';
segments{16}.number{1} = [1,84];
segments{16}.number{2} = [85,155];
segments{16}.chain =   {'A','A'};
location{16}{1} = [1,84]; 
location{16}{2} = [85,162];



%% protein 17
MSAfile{17} = 'MMM2FH7A_hits_nr90_2FH7A_nr90.fasta';
pdbfile1{17} = '2fh7a.pdb';
pdbfile2{17} = '2fh7a.pdb';
jobname{17} = '2fh7a';
segments{17}.number{1} = [1367,1653]; 
segments{17}.number{2} = [1654,1942];
segments{17}.chain =   {'A','A'};
location{17}{1} = [1, 292]; 
location{17}{2} = [293,  595];


%% protein 18
MSAfile{18}  = 'MMM2FL4A_hits_nr90_2FL4A_nr90.fasta';
pdbfile1{18} = '2fl4a.pdb';
pdbfile2{18} = '2fl4a.pdb';
jobname{18} = '2fl4a';
segments{18}.number{1} = [0,42]; 
segments{18}.number{2} = [43,146];
segments{18}.chain =   {'A','A'};
location{18}{1} = [1, 43]; 
location{18}{2} = [44,  149];


%% protein 19
MSAfile{19} = 'MMM1G8AA_hits_nr90_1G8AA_nr90.fasta';
pdbfile1{19}  = '1g8aa.pdb';
pdbfile2{19}  = '1g8aa.pdb';
jobname{19}  = '1g8aa';
segments{19} .number{1} = [1,51]; 
segments{19} .number{2} = [52,227];
segments{19} .chain =   {'A','A'};
location{19} {1} = [1, 51]; 
location{19} {2} = [52,  227];

%% protein 20
MSAfile{20} = 'MMM1G8PA_hits_nr90_1G8PA_nr90.fasta';
pdbfile1{20}  = '1g8pa.pdb';
pdbfile2{20}  = '1g8pa.pdb';
jobname{20}  = '1g8pa';
segments{20}.number{1} = [18,216];
segments{20} .number{2} = [261,350];
segments{20} .chain =   {'A','A'};
location{20}{1} = [1, 216]; 
location{20}{2} = [217,  350];

%% protein 21
MSAfile{21} = 'MMM1I39A_hits_nr90_1I39A_nr90.fasta';
pdbfile1{21}  = '1i39a.pdb';
pdbfile2{21}  = '1i39a.pdb';
jobname{21}  = '1i39a';
segments{21} .number{1} = [1, 158]; 
segments{21} .number{2} = [159, 200];
segments{21} .chain =   {'A','A'};
location{21} {1} = [1, 178]; 
location{21} {2} = [179,  225];

%% protein 22
MSAfile{22} = 'MMM1J5XA_hits_nr90_1J5XA_nr90.fasta';
pdbfile1{22} = '1j5xa.pdb';
pdbfile2{22} = '1j5xa.pdb';
jobname{22} = '1j5xa';
segments{22}.number{1} = [2, 169]; 
segments{22}.number{2} = [170, 319];
segments{22}.chain =   {'A','A'};
location{22}{1} = [1, 181]; 
location{22}{2} = [182, 342];

%% protein 23
MSAfile{23} = 'MMM2JDFA_hits_nr90_2JDFA_nr90.fasta';
pdbfile1{23} = '2jdfa.pdb';
pdbfile2{23} = '2jdfa.pdb';
jobname{23} = '2jdfa';
segments{23}.number{1} = [1,83]; 
segments{23}.number{2} = [84,173; 175,177];
segments{23}.chain =   {'A','A'};
location{23}{1} = [1, 83]; 
location{23}{2} = [84, 182];


%% protein 24
MSAfile{24} = 'MMM1LF4A_hits_nr90_1LF4A_nr90.fasta';
pdbfile1{24} = '1lf4a.pdb';
pdbfile2{24} = '1lf4a.pdb';
jobname{24} = '1lf4a';
segments{24}.number{1} = [1,175]; 
segments{24}.number{2} = [176,328];
segments{24}.chain =   {'A','A'};
location{24}{1} = [1, 177]; 
location{24}{2} = [178, 331];

%% protein 25
MSAfile{25} = 'MMM1MRIA_hits_nr90_1MRIA_nr90.fasta';
pdbfile1{25} = '1mria.pdb';
pdbfile2{25} = '1mria.pdb';
jobname{25} = '1mria';
segments{25}.number{1} = [1,162]; 
segments{25}.number{2} = [163,246];
segments{25}.chain =   {'A','A'};
location{25}{1} = [1, 162]; 
location{25}{2} = [163, 263];


%% protein 26
MSAfile{26} = 'MMM2NPOA_hits_nr90_2NPOA_nr90.fasta';
pdbfile1{26} = '2npoa.pdb';
pdbfile2{26} = '2npoa.pdb';
jobname{26} = '2npoa';
segments{26}.number{1} = [3,76];  
segments{26}.number{2} = [77,188];
segments{26}.chain =   {'A','A'};
location{26}{1} = [1, 78]; 
location{26}{2} = [79, 207];


%% protein 27
MSAfile{27} = 'MMM2OF7A_hits_nr90_2OF7A_nr90.fasta';
pdbfile1{27} = '2of7a.pdb';
pdbfile2{27} = '2of7a.pdb';
jobname{27} = '2of7a';
segments{27}.number{1} = [17,67]; 
segments{27}.number{2} = [68,207];
segments{27}.chain =   {'A','A'};
location{27}{1} = [1, 90]; 
location{27}{2} = [91, 260];

%% protein 28
MSAfile{28} = 'MMM2OV1A_hits_nr90_2OV1A_nr90.fasta';
pdbfile1{28}  = '2ov1a.pdb';
pdbfile2{28}  = '2ov1a.pdb';
jobname{28}  = '2ov1a';
segments{28} .number{1} = [47,141; 174,232]; 
segments{28} .number{2} = [233,338];
segments{28} .chain =   {'A','A'};
location{28} {1} = [1, 95; 96, 154]; 
location{28} {2} = [155, 260];


%% protein 29
MSAfile{29} = 'MMM2PGEA_hits_nr90_2PGEA_nr90.fasta';
pdbfile1{29} = '2pgea.pdb';
pdbfile2{29} = '2pgea.pdb';
jobname{29} = '2pgea';
segments{29}.number{1} = [3,136]; 
segments{29}.number{2} =  [137,368];
segments{29}.chain =   {'A','A'};
location{29}{1} = [1, 136];
location{29}{2} = [137 377];

%% protein 30
MSAfile{30} = 'MMM2PGXA_hits_nr90_2PGXA_nr90.fasta';
pdbfile1{30} = '2pgxa.pdb';
pdbfile2{30} = '2pgxa.pdb';
jobname{30} = '2pgxa';
segments{30}.number{1} = [2,56];
segments{30}.number{2} = [57,250];
segments{30}.chain =   {'A','A'};
location{30}{1} = [1, 56];
location{30}{2} = [57, 258];

%% protein 31
MSAfile{31} = 'MMM2PHZA_hits_nr90_2PHZA_nr90.fasta';
pdbfile1{31} = '2phza.pdb';
pdbfile2{31} = '2phza.pdb';
jobname{31} = '2phza';
segments{31}.number{1} = [20, 142];
segments{31}.number{2} = [143, 296];
segments{31}.chain =   {'A','A'};
location{31}{1} = [1, 147];
location{31}{2} = [148, 311];


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Detailed parameters for iPatch algorithm %
% these are the default settings below           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear parameters;
parameters.surfaceoption = 0; % if set to 0,the surface information for the domain interested is
                              % given by running the psa on the domain; if set it to
                              % 1, the surface information for the domain interested is
                              % given by running the psa on the whole protein on
                              % which this domain is located;
parameters.gapcutoff = 0.5;   % columns with gap percentage greater than this cutoff wont be used in the score calculation
parameters.discutoff = 4.5;   % the intra domain space neighbors are defined by this cutoff, i.e., if the distances 
                              % between residues that are measured as the
                              % shortest distance between any nonhydrogen atoms
                              % are less than this cutoff, these two
                              % residues are intra domain neighbors
parameters.parallelized = 0;  % 1, if you can run the matlabpool, most of the algorithms can be
                              % parallelized; 0, otherwise.
parameters.randomized = 0;    % 1, if you want to get the scores for the random matching pairs as backgroud score; 0, otherwise.
parameters.reference = 1;     % 1, if you want to include your reference sequence in the score calculation; 0, otherwise.  
parameters.cleancache = 1;    % clean all the cache files; if set to be 0, the cache files will be used, if any
parameters.modifiedres = 1;   % if 1, change MSE to MET, CSE to CSC; if 0, those modified residues will be ignored.
parameters.manualalignment = 0; % if 0, the alignment between the pdb sequence and the reference sequence 
                                % will be generated by using the local alignment algorithm swalign(); 
                                % if 1, the user specified alignment will be used for the residue number 
                                % assignment 

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Calculating scores  
%
%
%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
matlabpool
for pri = 1 : size(MSAfile,2)
    pri
    %% calling the iPatch
    result{pri} = iPatch(pdbfile1{pri}, pdbfile2{pri}, MSAfile{pri}, location{pri}, segments{pri}, jobname{pri}, parameters);
end
matlabpool close
% output data structure
% result.pairwisescores{1} pairPPro
% result.pairwisescores{2} pairTPro
% result.pairwisescores{3} pairMcBASC
% result.sitescores{1} APro
% result.sitescores{2} PPro
% result.sitescores{3} TPro
% result.sitescores{4} EBMcBASC
% result.sitescores{5} Comb
% result.protein  a structure data format with many fields
save('resulttestdata.mat','result')