%% structure neighbor locations, only exposed sites count
function neighborLocation = GetStructureNeighbor(i, protein, cutoff, EBindex)
locationMSA = protein.aln.nogap.locationMSA;
residue = protein.aln.nogap.residue;
seprate_site = protein.aln.nogap.seprate_site;
length = protein.aln.nogap.length;
resnumforI = get_resnum_from_locationMSA(locationMSA, residue, i);
if isin(i, protein.aln.nogap.locationMSA) && isInResidueSet(resnumforI, protein.aln.nogap.structure.residue)
    % location has a residue with structure information   
    neighborLocation = i; % the site itself must be in its neighborhood
    for k = 1 : size(protein.aln.nogap.distances,2)
        locationinStructureforI = get_locationMSA_from_resnum(protein.aln.nogap.structure.locationMSA,...
            protein.aln.nogap.structure.residue, resnumforI.number,...
            resnumforI.chain);
        if protein.aln.nogap.distances(locationinStructureforI,k) < cutoff
            seprate_site_structure = protein.aln.nogap.structure.seprate_site;
            if k <=  seprate_site_structure && locationinStructureforI <= seprate_site_structure ||...
                    locationinStructureforI > seprate_site_structure &&  k > seprate_site_structure
                % find a intra-contact
                if k ~= locationinStructureforI
                    % not include the site itself
                    resnum = get_resnum_from_locationMSA(protein.aln.nogap.structure.locationMSA,...
                        protein.aln.nogap.structure.residue, k);
                    location_nogap = get_locationMSA_from_resnum(protein.aln.nogap.locationMSA,...
                        protein.aln.nogap.residue, resnum.number, resnum.chain);
                    if EBindex(location_nogap) == 2
                        % only exposed sites count
                        neighborLocation = [neighborLocation, location_nogap];
                    end
                end
            end
        end
    end
else
    % it's a gap or the residue without structure information avaliable
    % use the sequence neighbors
    % neighbors on sequence
    %     if i <= seprate_site
    %         neighborLocation = GetSequenceNeighborLoction(i, 1, seprate_site);
    %     else
    %         neighborLocation = GetSequenceNeighborLoction(i, 1+seprate_site, length);
    %     end
    neighborLocation = i;
end
                    
                    
