%% call joy assign secondary structures and exposed/buried properties
function result = JoyInformationProtein(protein1, datapath)

if ~iscell(protein1)
    protein{1} = protein1;
else
    protein = protein1;
end
joycannot = [];
clear joypsa;
for i = 1 : size(protein,2)     
     % call joy for each protein       
     for j = 1 : size(protein{i}.aln.domain.number,2)
         t = 1;  
          % run Joy for each domain
         [s,w] = runUnix(datapath, ['psa ', datapath, protein{i}.pdbfiles{j}])        
         if s == 255
             joycannot = [joycannot, j];
         end       
         % psa for domain
         clear structure_info;
         structure_info = pdbread([datapath, protein{i}.pdbfiles{j}]);
         clear domainjoypsa;         
         domainjoypsa = readpsaJoy([datapath, protein{i}.pdbfiles{j}(1:end-4), '.psa'], ...
             structure_info);      
         for k = 1 : size(domainjoypsa,2)             
             joypsa{i,j}(t) = domainjoypsa(k);
             t = t + 1;
         end
     end 
end

%% since we run psa on the original pdb files, the chain ID is the original
%% chain IDs

% EBindex == 2 --> exposed
%         == 1 --> buried
%         == 0 --> no structure information
for i = 1 : size(protein,2)
    clear residue; clear locationMSA;
    residue = protein{i}.aln.nogap.residue;
    locationMSA = protein{i}.aln.nogap.locationMSA;
    EBindex{i} = zeros(1,protein{i}.aln.nogap.length);
    for j = 1 : size(residue.number,2)
        clear currentjoy;
        if residue.chain(j) == 'A'
            residue.chain(j) = protein{i}.domain.chain{1};
            currentjoy = joypsa{i,1};
        else
            residue.chain(j) = protein{i}.domain.chain{2};
            currentjoy = joypsa{i,2};
        end        
        for k = 1 : size(currentjoy,2)
            if residue.number(j) == currentjoy(k).resnum ...
                    && strcmpi(residue.chain(j), currentjoy(k).reschain)
                if currentjoy(k).totalside > 7
                    EBindex{i}(locationMSA(j)) = 2;   
                else
                    EBindex{i}(locationMSA(j)) = 1; 
                    break;
                end                 
            end               
        end
    end   
end

result.EBindex = EBindex; 
result.joypsa = joypsa;
