function makemypdbfile(protein, refsequece, filename, datapath, temppath)

residue = protein.residue;
% only remain those residues specified by the domain definition
for i = 1 : 2
    residue1.number = [];
    residue1.chain = [];
    for j = 1 : size(residue{i}.number,2)        
        key = 0;
        for k = 1 : size(protein.domain.number{i}, 1)
            if residue{i}.number(j) >= protein.domain.number{i}(k,1) ...
                    && residue{i}.number(j) <= protein.domain.number{i}(k,2)
                key = 1;
            end
        end
        if key == 1
            residue1.number = [residue1.number, residue{i}.number(j)];
            residue1.chain = [residue1.chain, residue{i}.chain(j)];
        end
    end
    residue{i}.number = []; residue{i}.chain = [];
    residue{i}  =  residue1;
end
% only extract the residues specified by the domain definition to make the
% refseq
for i = 1 : 2
    refseq{i} = [];
    for j = 1 : size(protein.aln.residue.number, 2)
        key = 0;
        for k = 1 : size(protein.domain.number{i}, 1)
            if protein.aln.residue.number(j) >= protein.domain.number{i}(k,1) ...
                    && protein.aln.residue.number(j) <= protein.domain.number{i}(k,2)   
                if i == 1 &&  protein.aln.residue.chain(j) == 'A'
                    key = 1;
                end
                if i == 2 && protein.aln.residue.chain(j) == 'B'
                    key = 1;
                end                    
            end
        end
        if key == 1
            refseq{i}  = [refseq{i}, refsequece(j)];
        end
    end
end

pdbfiles = protein.pdbfiles;
% extract the coordinates from pdbfile1, and pdbfile2 according to the
% protein.residue 
% make a clean pdb file: only ATOM; only the A alternative location for
% ATOM; only 24 amino acids; 
% in the mynewpdb.pdb, the first domain will be chain A, the second domain
% will be chain B

% the refseq here only for varifying the residue assignment once again
% we need to take into account the non-continuous locations of the domain
% as well

fidnew = fopen([temppath, filename],'w');
fidnew1 = fopen([temppath, 'Domain1',protein.names,'.pdb'], 'w');
fidnew2 = fopen([temppath, 'Domain2', protein.names, '.pdb'], 'w');
for i = 1 : 2
    fid = fopen([datapath, pdbfiles{i}], 'r');
    tline = [];
    while 1
        tline = fgets(fid);
        if ~ischar(tline),   break,   end
        if size(tline,2) > 4
            if strcmpi(tline(1:4), 'ATOM')
                if ~strcmpi(tline(18:20), 'UNK')
                    if strcmpi(tline(27),' ') % not insertion of residue
                        if strcmp(tline(17), 'A') || strcmp(tline(17), ' ') % alternate location A
                            tline(17) = ' ';                            
                            % check the residue
                            for j = 1 : size(residue{i}.number,2)
                                % check resSeqNum and resChainID
                                if residue{i}.number(j) == str2num(tline(23:26)) ...
                                        && strcmpi(residue{i}.chain(j), tline(22))
                                    % resName 
                                    if strcmpi(refseq{i}(j), myaminolookup(tline(18:20)))
                                        if i == 1
                                            tline(22) = 'A';
                                            fprintf(fidnew1, '%s', tline);
                                        else
                                            tline(22) = 'B';
                                            fprintf(fidnew2, '%s', tline);
                                        end
                                        fprintf(fidnew, '%s', tline);
                                    else
                                        disp(['the residue number assigned to the ', num2str(j), ...
                                            '-th residue ', refseq{i}(j), ' in the reference sequence ', ...
                                            'is ', num2str(residue{i}.number(j)), ' on the ', num2str(i), ' protein ']);
                                        disp([',but in the pdbfile this resNum belongs to residue ', tline(18:20)]);
                                        disp('please make sure the residue sequence number is consistent,');
                                        disp('since we need this to find the right coordinates.');
                                        disp('ctrl+c stops the program')
                                        pause();
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
    end
    fclose(fid);
end
fclose(fidnew);
fclose(fidnew1);
fclose(fidnew2);







