%% AA composition score for each column
% stats.AApropensity = AApropensity;  
% stats.Pairpropensity = Pairpropensity;
% stats.Trianglepropensity = Trianglepropensity;
% stats.neighborhood_intra = neighborhood_intra;
% stats.neighborhood_inter = neighborhood_inter;
% propensity for contactSites, noncontactSites, and difference between them

function score = pAAScore(alignment, stats, proteinname, temppath)
% using the difference between propensities of contact and noncontact sites
% on the surface
pcaa = stats.AA20propensity{3};
aminonames = {'R', 'N', 'D', 'C', 'Q', 'E', 'G', 'H', 'I', 'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V', 'A'};
num_seq = size(alignment,1);
num_column = size(alignment(1,1).Sequence, 2);
mapped_index20 = -1 * ones(num_seq, num_column);
fiddata = fopen([temppath, 'IndexMSA20AA', proteinname,'.mat']);
if fiddata == -1    
    for i = 1 : num_seq
        for j = 1 : num_column
            mapped_index20(i,j) = MapResiduesToIndex20(alignment(i,1).Sequence(j), aminonames);
        end
    end
    save([temppath, 'IndexMSA20AA', proteinname,'.mat'], 'mapped_index20');
else
    fclose(fiddata);
    clear tempdata;
    tempdata = load([temppath, 'IndexMSA20AA', proteinname,'.mat']);
    mapped_index20 = tempdata.mapped_index20;
    clear tempdata;    
end

% pcaa = [1.3571,0.8801,0.8635,0.9794,1.0115,0.9403,0.7253,1.2815,1.1157,1.1552,0.8365,1.3434,1.2992,0.8774,0.8417,0.9764,1.6737,1.3902,1.0741,0.7405;];
score = zeros(1, num_column);
for j = 1 : num_column
    t = 1;
    for i = 1 : num_seq
        if mapped_index20(i,j) > 0
            score(1,j) = score(1,j) + pcaa(mapped_index20(i,j));
            t = t + 1;
        end
    end
    score(1,j) = score(1,j) / t;
end